<template>
  <div>
    <el-card class="el-card">
      <el-form :model="listQuery" label-width="120px" v-show="showSearch">
        <el-row>
          <el-col :span="24">
            <el-form-item label="UDI码:" class="query-form-item">
              <el-input v-model="listQuery.udiCode" style="width: 98%" placeholder="请扫描或输入UDI码" clearable="true"
                        @keyup.enter.native="keyup_submit($event)"></el-input>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="8">
            <el-form-item label="产品标识:" class="query-form-item">
              <el-input clearable v-model="listQuery.nameCode" style="width: 90%" placeholder="请输入最小销售产品标识"/>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="物品编码:" class="query-form-item">
              <el-input v-model="listQuery.unionCode" style="width: 90%" placeholder="请输入DI/医保编码/商品条码"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="产品通用名:" class="query-form-item">
              <el-input v-model="listQuery.cpmctymc" style="width: 90%" placeholder="请输入产品通用名"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>

        </el-row>
        <el-row>
          <el-col :span="8">
            <el-form-item label="规格型号:" class="query-form-item">
              <el-input v-model="listQuery.ggxh" style="width: 90%" placeholder="请输入规格型号" clearable="true"></el-input>
            </el-form-item>
          </el-col>

          <el-col :span="8">
            <el-form-item label="生产企业:" class="query-form-item">
              <el-input v-model="listQuery.ylqxzcrbarmc" style="width: 90%" placeholder="请输入生产企业/注册备案人"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>

      <div class="top-right-btn">
        <el-button-group style="display:flex;">
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
          <el-button type="primary" icon="el-icon-search" @click="search">查询</el-button>
          <el-button type="primary" icon="el-icon-plus" @click="confirmSelect">确定</el-button>
        </el-button-group>
      </div>
<!--      <el-divider style="margin: 15px"></el-divider>-->

      <el-table :data="productList" style="width: 100%"
                v-loading="productListLoading" border highlight-current-row
                :row-class-name="tableRowClassName" @current-change="handleChange" ref="multipleTable"
                @selection-change="productSelectChange">
        <el-table-column type="selection" width="55" :selectable="selectableDIS"></el-table-column>
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="最小销售产品标识" width="150" prop="nameCode" show-overflow-tooltip></el-table-column>
        <el-table-column label="产品通用名称" width="150" prop="cpmctymc" show-overflow-tooltip></el-table-column>
        <el-table-column label="规格型号" width="150" prop="ggxh" show-overflow-tooltip></el-table-column>
        <el-table-column label="注册/备案号" width="150" prop="zczbhhzbapzbh" show-overflow-tooltip></el-table-column>
        <el-table-column label="生产企业" width="200" prop="manufactory" show-overflow-tooltip></el-table-column>
        <el-table-column label="产品描述" width="200" prop="cpms" show-overflow-tooltip></el-table-column>
        <el-table-column label="操作" width="160">
          <template slot-scope="scope">
            <el-button type="text" size="small" @click.native.stop="handleDetailClick(scope.row)">详情</el-button>
          </template>
        </el-table-column>
      </el-table>

      <el-dialog
        title="耗材字典详情"
        :visible.sync="udiRlDetailVisible"
        width="80%"
        :close-on-click-modal="false"
        :close-on-press-escape="false"
        append-to-body
        v-if="udiRlDetailVisible"
      >
        <udiRlDetailDialog :editQuery="currentRow"></udiRlDetailDialog>
      </el-dialog>

      <pagination
        v-show="productListTotal>0"
        :total="productListTotal"
        :page.sync="listQuery.page"
        :limit.sync="listQuery.limit"
        @pagination="handleErpPageChange"

      ></pagination>
    </el-card>


    <el-dialog title="请选择对应的注册/备案证" :visible.sync="dialogFormVisible" append-to-body width="40%">
      <el-form :model="form">
        <el-form-item label="" prop="isGive">
          <el-radio-group v-model="currentCert">
            <el-radio style="width: 100%;  margin-top: 10px;" :label="item" :key="item" v-for="item in certList">{{
                item
              }}
            </el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="selectCert">确 定</el-button>
        <el-button @click="dialogFormVisible = false">取 消</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
// import store from "../../../store";
import {addContractDetail} from "@/api/purchase/purContract"
import {isBlank} from "@/utils/strUtil";
// import selectProduct from "@/views/order/pur/selectProduct.vue";
// import {productListWithUnique, productListWithUniqueAndUnit} from "@/api/receipts/productInfo";
import udiRlDetailDialog from "./../../purchase/purApply/purUdiRlDetailDialog";
import {filterCompanyProductRelevance} from "../../../api/basic/udiRlSuptRelevance";

export default {
  name: "stockOrderNewSelectProduct",
  props: {
    stockOrderLists: {
      type: Object,
      required: true,
    },
    closeDialog: {
      type: Function,
      required: true,
    },
    closeDialogC2: {
      type: Function,
      required: true,
    },
    purType: {
      type: Object,
      required: true,
    },
    pId: {
      type: Object,
      required: true,
    },
  },

  data() {
    return {
      productList:[],
      showSearch: true,
      listQuery: {
        purType: null,
        udiCode: null,
        unicode: null,
        nameCode: null,
        cpmctymc: null,
        ggxh: null,
        ylqxzcrbarmc: null,
        thrPiId: null,
        corpType:'VENDOR',
        page: 1,
        limit: 10,
      },
      combineQuery: {
        thirdId: "",
        relId: "",
        erpName: "",
        keys: [],
      },
      ids: [],
      radioCheck: null,
      dataList: [],
      pageTotal: 1,
      total: 1,
      currentRow: null,
      productListLoading: false,
      udiRlDetailVisible: false,
      thirdSys: [],
      thirdSysFk: null,
      busTypes: [],
      actDateRange: [],
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      orderEditor: false,
      orderId: "",
      currentCert: null,
      certList: [],
      dialogFormVisible: false,
      multipleSelection: null,
      uniqueIds: [],
    };
  },
  methods: {
    selectableDIS(row, index) {
      if (this.stockOrderLists.length > 0) {
        for (var i = 0; i < this.stockOrderLists.length; i++) {
          if (row.rlId == this.stockOrderLists[i].productId){
            return false
          }
        }
      }
      return  true
    },
    productSelectChange(e) {
      this.uniqueIds = []
      e.forEach(i => this.uniqueIds.push({productUniqueId: i.uniqueId, id: i.id || null}));
    },
    onReset() {
      this.$router.push({
        path: "",
      });
      this.listQuery = {
        purType: null,
        udiCode: null,
        unicode: null,
        cpmctymc: null,
        ggxh: null,
        ylqxzcrbarmc: null,
        thrPiId: null,
        page: 1,
        limit: 10
      }
      this.multipleSelection = [];
      this.radioCheck = null;
      this.currentRow = null;
      this.getList();
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    tableRowClassName({row}) {
      if (row.checked) return "warning-row";
      return "";
    },
    checkSelectable(row) {
      return !row.check;
    },
    handleCurrentChange(val) {
      this.unionQuery.page = val;
      this.getList();
    },
    handleChange(val) {
      this.radioCheck = val.id;
      this.currentRow = val;
      this.multipleSelection = val
    },
    handleDetailClick(row) {
      this.currentRow = row;
      this.udiRlDetailVisible = true;

    },
    closeDetailDialog() {
      this.udiRlDetailVisible = false;
    },
    handleErpPageChange(val) {
      this.listQuery.page = val.page;
      this.getList();
    },
    keyup_submit(event) {
      this.listQuery.page = 1;
      this.getList();
      event.target.select();
    },
    search() {
      this.listQuery.page = 1;
      this.getList();
    },
    getList() {
      this.productListLoading = true;
      // this.listQuery.customerId = store.getters.customerId;
      filterCompanyProductRelevance(this.listQuery).then(res => {
        this.productListLoading = false
        if (res.code === 20000) {
          this.productList = res.data.list || []
          this.productListTotal = res.data.total || 0
        } else {
          this.$message.error(res.message)
        }
      }).catch((e) => {
        this.productListLoading = false
      })
    },
    intentBack() {
      this.closeDialog();
    },


    confirmSelect() {
      if (!this.uniqueIds.length) {
        this.$message.error("请先选择产品")
        return
      }
      this.combine();
      this.closeDialog();
    },

    combine() {
      this.loading = true;
      let arr = []
      this.uniqueIds.forEach((value, index) => {
        arr[index] = value.id;
      });

      if (arr.length == 0){
        this.$message.error("请先选择产品！");
        return
      }

      let tQuery = {
        productIds : arr,
        orderIdFk: this.pId
      };

      addContractDetail(tQuery).then((response) => {
        this.loading = false;
        if (response.code === 20000) {
          this.closeDialog(response.data);
        } else {
          if (response.code == 601) {
            this.$alert(response.message, "提示", {
              confirmButtonText: "确定",
            });
          } else
            this.$message.error(response.message);
        }
      }).catch(() => {
        this.loading = false;
      });

    },

    selectCert() {
      if (this.currentCert == null) {
        this.$message.error("请先选择对应的注册证！");
      } else {
        this.multipleSelection.zczbhhzbapzbh = this.currentCert;
        this.combine();
      }

    },
  },
  components: {
    udiRlDetailDialog

  },

  created() {

    this.getList();
  },
};
</script>

<style scoped>


div /deep/ .el-table .warning-row {
  background: #bebebe;
}

div /deep/ .el-table .success-row {
  background: #ffffff;
}
</style>
